searchNodes=[{"doc":"SDK to facilitate Elixir integrations with the Stark Bank API v2.","ref":"StarkBank.html","title":"StarkBank","type":"module"},{"doc":"Creates a Project struct The Project struct is the main authentication entity for the SDK. All requests to the Stark Bank API must be authenticated via a project, which must have been previously created at the Stark Bank website [https://sandbox.web.starkbank.com] or [https://web.starkbank.com] before you can use it in this SDK. Projects may be passed as a parameter on each request or may be defined as the default user at the start (See README). Parameters (required): environment [string]: environment where the project is being used. ex: &quot;sandbox&quot; or &quot;production&quot; id [string]: unique id required to identify project. ex: &quot;5656565656565656&quot; private_key [string]: PEM string of the private key linked to the project. ex: &quot;-----BEGIN PUBLIC KEY----- MFYwEAYHKoZIzj0CAQYFK4EEAAoDQgAEyTIHK6jYuik6ktM9FIF3yCEYzpLjO5X/ tqDioGM+R2RyW0QEo+1DG8BrUf4UXHSvCjtQ0yLppygz23z0yPZYfw== -----END PUBLIC KEY-----&quot; Attributes (return-only): name [string, default &quot;&quot;]: project name. ex: &quot;MyProject&quot; allowed_ips [list of strings]: list containing the strings of the ips allowed to make requests on behalf of this project. ex: [&quot;190.190.0.50&quot;]","ref":"StarkBank.html#project/5","title":"StarkBank.project/5","type":"function"},{"doc":"Groups Balance related functions Balance struct: The Balance struct displays the current balance of the workspace, which is the result of the sum of all transactions within this workspace. The balance is never generated by the user, but it can be retrieved to see the information available. Attributes (return-only): id [string, default nil]: unique id returned when Boleto is created. ex: &quot;5656565656565656&quot; amount [integer, default nil]: current balance amount of the workspace in cents. ex: 200 (= R$ 2.00) currency [string, default nil]: currency of the current workspace. Expect others to be added eventually. ex: &quot;BRL&quot; updated [DateTime, default nil]: update datetime for the balance. ex: ~U[2020-03-26 19:32:35.418698Z]","ref":"StarkBank.Balance.html","title":"StarkBank.Balance","type":"module"},{"doc":"Retrieve the Balance entity Receive the Balance entity linked to your workspace in the Stark Bank API Parameters (required): user [Project]: Project struct returned from StarkBank.project(). Return: Balance struct with updated attributes","ref":"StarkBank.Balance.html#get/1","title":"StarkBank.Balance.get/1","type":"function"},{"doc":"Same as get(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.Balance.html#get!/1","title":"StarkBank.Balance.get!/1","type":"function"},{"doc":"","ref":"StarkBank.Balance.html#t:t/0","title":"StarkBank.Balance.t/0","type":"type"},{"doc":"Groups Boleto related functions Boleto struct: When you initialize a Boleto struct, the entity will not be automatically sent to the Stark Bank API. The &#39;create&#39; function sends the structs to the Stark Bank API and returns the list of created structs. Parameters (required): amount [integer]: Boleto value in cents. Minimum amount = 200 (R$2,00). ex: 1234 (= R$ 12.34) name [string]: payer full name. ex: &quot;Anthony Edward Stark&quot; tax_id [string]: payer tax ID (CPF or CNPJ) with or without formatting. ex: &quot;01234567890&quot; or &quot;20.018.183/0001-80&quot; street_line_1 [string]: payer main address. ex: Av. Paulista, 200 street_line_2 [string]: payer address complement. ex: Apto. 123 district [string]: payer address district / neighbourhood. ex: Bela Vista city [string]: payer address city. ex: Rio de Janeiro state_code [string]: payer address state. ex: GO zip_code [string]: payer address zip code. ex: 01311-200 due [Date, default today + 2 days]: Boleto due date in ISO format. ex: 2020-04-30 Parameters (optional): fine [float, default 0.0]: Boleto fine for overdue payment in %. ex: 2.5 interest [float, default 0.0]: Boleto monthly interest for overdue payment in %. ex: 5.2 overdue_limit [integer, default 59]: limit in days for automatic Boleto cancellation after due date. ex: 7 (max: 59) descriptions [list of maps, default nil]: list of maps with :text (string) and :amount (int, optional) pairs tags [list of strings]: list of strings for tagging Attributes (return-only): id [string, default nil]: unique id returned when Boleto is created. ex: &quot;5656565656565656&quot; fee [integer, default nil]: fee charged when Boleto is paid. ex: 200 (= R$ 2.00) line [string, default nil]: generated Boleto line for payment. ex: &quot;34191.09008 63571.277308 71444.640008 5 81960000000062&quot; bar_code [string, default nil]: generated Boleto bar-code for payment. ex: &quot;34195819600000000621090063571277307144464000&quot; status [string, default nil]: current Boleto status. ex: &quot;registered&quot; or &quot;paid&quot; created [DateTime, default nil]: creation datetime for the Boleto. ex: ~U[2020-03-26 19:32:35.418698Z]","ref":"StarkBank.Boleto.html","title":"StarkBank.Boleto","type":"module"},{"doc":"Create Boletos Send a list of Boleto structs for creation in the Stark Bank API Parameters (required): user [Project]: Project struct returned from StarkBank.project(). boletos [list of Boleto structs]: list of Boleto structs to be created in the API Return: list of Boleto structs with updated attributes","ref":"StarkBank.Boleto.html#create/2","title":"StarkBank.Boleto.create/2","type":"function"},{"doc":"Same as create(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.Boleto.html#create!/2","title":"StarkBank.Boleto.create!/2","type":"function"},{"doc":"Delete list of Boleto entities Delete a list of Boleto entities previously created in the Stark Bank API Parameters (required): user [Project]: Project struct returned from StarkBank.project(). id [string]: Boleto unique id. ex: &quot;5656565656565656&quot; Return: deleted Boleto struct with updated attributes","ref":"StarkBank.Boleto.html#delete/2","title":"StarkBank.Boleto.delete/2","type":"function"},{"doc":"Same as delete(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.Boleto.html#delete!/2","title":"StarkBank.Boleto.delete!/2","type":"function"},{"doc":"Retrieve a specific Boleto Receive a single Boleto struct previously created in the Stark Bank API by passing its id Parameters (required): user [Project]: Project struct returned from StarkBank.project(). id [string]: struct unique id. ex: &quot;5656565656565656&quot; Return: Boleto struct with updated attributes","ref":"StarkBank.Boleto.html#get/2","title":"StarkBank.Boleto.get/2","type":"function"},{"doc":"Same as get(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.Boleto.html#get!/2","title":"StarkBank.Boleto.get!/2","type":"function"},{"doc":"Retrieve a specific Boleto pdf file Receive a single Boleto pdf file generated in the Stark Bank API by passing its id. Parameters (required): user [Project]: Project struct returned from StarkBank.project(). id [string]: struct unique id. ex: &quot;5656565656565656&quot; Return: Boleto pdf file content","ref":"StarkBank.Boleto.html#pdf/2","title":"StarkBank.Boleto.pdf/2","type":"function"},{"doc":"Same as pdf(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.Boleto.html#pdf!/2","title":"StarkBank.Boleto.pdf!/2","type":"function"},{"doc":"Retrieve Boletos Receive a stream of Boleto structs previously created in the Stark Bank API Parameters (required): user [Project]: Project struct returned from StarkBank.project(). Parameters (optional): limit [integer, default nil]: maximum number of structs to be retrieved. Unlimited if nil. ex: 35 status [string, default nil]: filter for status of retrieved structs. ex: &quot;paid&quot; or &quot;registered&quot; tags [list of strings, default nil]: tags to filter retrieved structs. ex: [&quot;tony&quot;, &quot;stark&quot;] ids [list of strings, default nil]: list of ids to filter retrieved structs. ex: [&quot;5656565656565656&quot;, &quot;4545454545454545&quot;] after [Date, default nil] date filter for structs created only after specified date. ex: Date(2020, 3, 10) before [Date, default nil] date filter for structs only before specified date. ex: Date(2020, 3, 10) Return: stream of Boleto structs with updated attributes","ref":"StarkBank.Boleto.html#query/2","title":"StarkBank.Boleto.query/2","type":"function"},{"doc":"Same as query(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.Boleto.html#query!/2","title":"StarkBank.Boleto.query!/2","type":"function"},{"doc":"","ref":"StarkBank.Boleto.html#t:t/0","title":"StarkBank.Boleto.t/0","type":"type"},{"doc":"Groups Boleto.Log related functions Boleto.Log struct: Every time a Boleto entity is updated, a corresponding Boleto.Log is generated for the entity. This log is never generated by the user, but it can be retrieved to check additional information on the Boleto. Attributes: id [string]: unique id returned when the log is created. ex: &quot;5656565656565656&quot; boleto [Boleto]: Boleto entity to which the log refers to. errors [list of strings]: list of errors linked to this Boleto event type [string]: type of the Boleto event which triggered the log creation. ex: &quot;registered&quot; or &quot;paid&quot; created [DateTime]: creation datetime for the boleto. ex: ~U[2020-03-26 19:32:35.418698Z]","ref":"StarkBank.Boleto.Log.html","title":"StarkBank.Boleto.Log","type":"module"},{"doc":"Retrieve a specific Log Receive a single Log struct previously created by the Stark Bank API by passing its id Parameters (required): user [Project]: Project struct returned from StarkBank.project(). id [string]: struct unique id. ex: &quot;5656565656565656&quot; Return: Log struct with updated attributes","ref":"StarkBank.Boleto.Log.html#get/2","title":"StarkBank.Boleto.Log.get/2","type":"function"},{"doc":"Same as get(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.Boleto.Log.html#get!/2","title":"StarkBank.Boleto.Log.get!/2","type":"function"},{"doc":"Retrieve Logs Receive a stream of Log structs previously created in the Stark Bank API Parameters (required): user [Project]: Project struct returned from StarkBank.project(). Parameters (optional): limit [integer, default nil]: maximum number of structs to be retrieved. Unlimited if nil. ex: 35 boleto_ids [list of strings, default nil]: list of Boleto ids to filter logs. ex: [&quot;5656565656565656&quot;, &quot;4545454545454545&quot;] types [list of strings, default nil]: filter for log event types. ex: &quot;paid&quot; or &quot;registered&quot; after [Date, default nil] date filter for structs created only after specified date. ex: Date(2020, 3, 10) before [Date, default nil] date filter for structs only before specified date. ex: Date(2020, 3, 10) Return: stream of Log structs with updated attributes","ref":"StarkBank.Boleto.Log.html#query/2","title":"StarkBank.Boleto.Log.query/2","type":"function"},{"doc":"Same as query(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.Boleto.Log.html#query!/2","title":"StarkBank.Boleto.Log.query!/2","type":"function"},{"doc":"","ref":"StarkBank.Boleto.Log.html#t:t/0","title":"StarkBank.Boleto.Log.t/0","type":"type"},{"doc":"Groups BoletoPayment related functions BoletoPayment struct: When you initialize a BoletoPayment, the entity will not be automatically created in the Stark Bank API. The &#39;create&#39; function sends the structs to the Stark Bank API and returns the list of created structs. Parameters (conditionally required): line [string, default nil]: Number sequence that describes the payment. Either &#39;line&#39; or &#39;bar_code&#39; parameters are required. If both are sent, they must match. ex: &quot;34191.09008 63571.277308 71444.640008 5 81960000000062&quot; bar_code [string, default nil]: Bar code number that describes the payment. Either &#39;line&#39; or &#39;barCode&#39; parameters are required. If both are sent, they must match. ex: &quot;34195819600000000621090063571277307144464000&quot; Parameters (required): tax_id [string]: receiver tax ID (CPF or CNPJ) with or without formatting. ex: &quot;01234567890&quot; or &quot;20.018.183/0001-80&quot; description [string]: Text to be displayed in your statement (min. 10 characters). ex: &quot;payment ABC&quot; Parameters (optional): scheduled [Date, default today]: payment scheduled date. ex: ~D[2020-03-25] tags [list of strings]: list of strings for tagging Attributes (return-only): id [string, default nil]: unique id returned when payment is created. ex: &quot;5656565656565656&quot; status [string, default nil]: current payment status. ex: &quot;registered&quot; or &quot;paid&quot; amount [int, default nil]: amount automatically calculated from line or bar_code. ex: 23456 (= R$ 234.56) fee [integer, default nil]: fee charged when a boleto payment is created. ex: 200 (= R$ 2.00) created [DateTime, default nil]: creation datetime for the payment. ex: ~U[2020-03-26 19:32:35.418698Z]","ref":"StarkBank.BoletoPayment.html","title":"StarkBank.BoletoPayment","type":"module"},{"doc":"Create BoletoPayments Send a list of BoletoPayment structs for creation in the Stark Bank API Parameters (required): user [Project]: Project struct returned from StarkBank.project(). payments [list of BoletoPayment structs]: list of BoletoPayment structs to be created in the API Return: list of BoletoPayment structs with updated attributes","ref":"StarkBank.BoletoPayment.html#create/2","title":"StarkBank.BoletoPayment.create/2","type":"function"},{"doc":"Same as create(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.BoletoPayment.html#create!/2","title":"StarkBank.BoletoPayment.create!/2","type":"function"},{"doc":"Delete a BoletoPayment entity Delete a BoletoPayment entity previously created in the Stark Bank API Parameters (required): user [Project]: Project struct returned from StarkBank.project(). id [string]: BoletoPayment unique id. ex: &quot;5656565656565656&quot; Return: deleted BoletoPayment struct with updated attributes","ref":"StarkBank.BoletoPayment.html#delete/2","title":"StarkBank.BoletoPayment.delete/2","type":"function"},{"doc":"Same as delete(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.BoletoPayment.html#delete!/2","title":"StarkBank.BoletoPayment.delete!/2","type":"function"},{"doc":"Retrieve a specific BoletoPayment Receive a single BoletoPayment struct previously created by the Stark Bank API by passing its id Parameters (required): user [Project]: Project struct returned from StarkBank.project(). id [string]: struct unique id. ex: &quot;5656565656565656&quot; Return: BoletoPayment struct with updated attributes","ref":"StarkBank.BoletoPayment.html#get/2","title":"StarkBank.BoletoPayment.get/2","type":"function"},{"doc":"Same as get(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.BoletoPayment.html#get!/2","title":"StarkBank.BoletoPayment.get!/2","type":"function"},{"doc":"Retrieve a specific BoletoPayment pdf file Receive a single BoletoPayment pdf file generated in the Stark Bank API by passing its id. Only valid for boleto payments with &quot;success&quot; status. Parameters (required): user [Project]: Project struct returned from StarkBank.project(). id [string]: struct unique id. ex: &quot;5656565656565656&quot; Return: BoletoPayment pdf file content","ref":"StarkBank.BoletoPayment.html#pdf/2","title":"StarkBank.BoletoPayment.pdf/2","type":"function"},{"doc":"Same as pdf(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.BoletoPayment.html#pdf!/2","title":"StarkBank.BoletoPayment.pdf!/2","type":"function"},{"doc":"Retrieve BoletoPayments Receive a stream of BoletoPayment structs previously created in the Stark Bank API Parameters (required): user [Project]: Project struct returned from StarkBank.project(). Parameters (optional): limit [integer, default nil]: maximum number of structs to be retrieved. Unlimited if nil. ex: 35 status [string, default nil]: filter for status of retrieved structs. ex: &quot;paid&quot; tags [list of strings, default nil]: tags to filter retrieved structs. ex: [&quot;tony&quot;, &quot;stark&quot;] after [Date, default nil] date filter for structs created only after specified date. ex: Date(2020, 3, 10) before [Date, default nil] date filter for structs only before specified date. ex: Date(2020, 3, 10) Return: stream of BoletoPayment structs with updated attributes","ref":"StarkBank.BoletoPayment.html#query/2","title":"StarkBank.BoletoPayment.query/2","type":"function"},{"doc":"Same as query(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.BoletoPayment.html#query!/2","title":"StarkBank.BoletoPayment.query!/2","type":"function"},{"doc":"","ref":"StarkBank.BoletoPayment.html#t:t/0","title":"StarkBank.BoletoPayment.t/0","type":"type"},{"doc":"Groups BoletoPayment.Log related functions BoletoPayment.Log struct: Every time a BoletoPayment entity is modified, a corresponding BoletoPayment.Log is generated for the entity. This log is never generated by the user, but it can be retrieved to check additional information on the BoletoPayment. Attributes: id [string]: unique id returned when the log is created. ex: &quot;5656565656565656&quot; payment [BoletoPayment]: BoletoPayment entity to which the log refers to. errors [list of strings]: list of errors linked to this BoletoPayment event. type [string]: type of the BoletoPayment event which triggered the log creation. ex: &quot;registered&quot; or &quot;paid&quot; created [DateTime]: creation datetime for the payment. ex: ~U[2020-03-26 19:32:35.418698Z]","ref":"StarkBank.BoletoPayment.Log.html","title":"StarkBank.BoletoPayment.Log","type":"module"},{"doc":"Retrieve a specific Log Receive a single Log struct previously created by the Stark Bank API by passing its id Parameters (required): user [Project]: Project struct returned from StarkBank.project(). id [string]: struct unique id. ex: &quot;5656565656565656&quot; Return: Log struct with updated attributes","ref":"StarkBank.BoletoPayment.Log.html#get/2","title":"StarkBank.BoletoPayment.Log.get/2","type":"function"},{"doc":"Same as get(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.BoletoPayment.Log.html#get!/2","title":"StarkBank.BoletoPayment.Log.get!/2","type":"function"},{"doc":"Retrieve Logs Receive a stream of Log structs previously created in the Stark Bank API Parameters (required): user [Project]: Project struct returned from StarkBank.project(). Parameters (optional): limit [integer, default nil]: maximum number of entities to be retrieved. Unlimited if nil. ex: 35 after [Date, default nil] date filter for entities created only after specified date. ex: Date(2020, 3, 10) before [Date, default nil] date filter for entities only before specified date. ex: Date(2020, 3, 10) payment_ids [list of strings, default nil]: list of BoletoPayment ids to filter retrieved entities. ex: [&quot;5656565656565656&quot;, &quot;4545454545454545&quot;] types [list of strings, default nil]: filter retrieved entities by event types. ex: &quot;paid&quot; or &quot;registered&quot; Return: stream of Log structs with updated attributes","ref":"StarkBank.BoletoPayment.Log.html#query/2","title":"StarkBank.BoletoPayment.Log.query/2","type":"function"},{"doc":"Same as query(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.BoletoPayment.Log.html#query!/2","title":"StarkBank.BoletoPayment.Log.query!/2","type":"function"},{"doc":"","ref":"StarkBank.BoletoPayment.Log.html#t:t/0","title":"StarkBank.BoletoPayment.Log.t/0","type":"type"},{"doc":"Error generated on interactions with the API If the error code is: &quot;internalServerError&quot;: the API has run into an internal error. If you ever stumble upon this one, rest assured that the development team is already rushing in to fix the mistake and get you back up to speed. &quot;unknownException&quot;: a request encounters an error that has not been sent by the API, such as connectivity problems. any other binary: the API has detected a mistake in your request Attributes: code [string]: defines de error code. ex: &quot;invalidCredentials&quot; message [string]: explains the detected error. ex: &quot;Provided digital signature in the header Access-Signature does not check out. See https://docs.api.starkbank.com/#auth for details.&quot;","ref":"StarkBank.Error.html","title":"StarkBank.Error","type":"module"},{"doc":"Groups Webhook-Event related functions Event struct: An Event is the notification received from the subscription to the Webhook. Events cannot be created, but may be retrieved from the Stark Bank API to list all generated updates on entities. Attributes: id [string]: unique id returned when the log is created. ex: &quot;5656565656565656&quot; log [Log]: a Log struct from one the subscription services (Transfer.Log, Boleto.Log, BoletoPayment.log or UtilityPayment.Log) created [DateTime]: creation datetime for the notification event. ex: ~U[2020-03-26 19:32:35.418698Z] is_delivered [bool]: true if the event has been successfully delivered to the user url. ex: false subscription [string]: service that triggered this event. ex: &quot;transfer&quot;, &quot;utility-payment&quot;","ref":"StarkBank.Event.html","title":"StarkBank.Event","type":"module"},{"doc":"Delete notification Events Delete a list of notification Event entities previously created in the Stark Bank API Parameters (required): user [Project]: Project struct returned from StarkBank.project(). id [string]: Event unique id. ex: &quot;5656565656565656&quot; Return: deleted Event struct with updated attributes","ref":"StarkBank.Event.html#delete/2","title":"StarkBank.Event.delete/2","type":"function"},{"doc":"Same as delete(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.Event.html#delete!/2","title":"StarkBank.Event.delete!/2","type":"function"},{"doc":"Retrieve a specific notification Event Receive a single notification Event struct previously created in the Stark Bank API by passing its id Parameters (required): user [Project]: Project struct returned from StarkBank.project(). id [string]: struct unique id. ex: &quot;5656565656565656&quot; Return: Event struct with updated attributes","ref":"StarkBank.Event.html#get/2","title":"StarkBank.Event.get/2","type":"function"},{"doc":"Same as get(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.Event.html#get!/2","title":"StarkBank.Event.get!/2","type":"function"},{"doc":"Create single notification Event from a content string Create a single Event struct received from event listening at subscribed user endpoint. If the provided digital signature does not check out with the StarkBank public key, an &quot;invalidSignature&quot; error will be returned. Parameters (required): user [Project]: Project struct returned from StarkBank.project(). content [string]: response content from request received at user endpoint (not parsed) signature [string]: base-64 digital signature received at response header &quot;Digital-Signature&quot; cache_pid [PID, default nil]: PID of the process that holds the public key cache, returned on previous parses. If not provided, a new cache process will be generated. Return: Event struct with updated attributes Cache PID that holds the Stark Bank public key in order to avoid unnecessary requests to the API on future parses","ref":"StarkBank.Event.html#parse/4","title":"StarkBank.Event.parse/4","type":"function"},{"doc":"Same as parse(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.Event.html#parse!/4","title":"StarkBank.Event.parse!/4","type":"function"},{"doc":"Retrieve notification Events Receive a stream of notification Event structs previously created in the Stark Bank API Parameters (required): user [Project]: Project struct returned from StarkBank.project(). Parameters (optional): limit [integer, default nil]: maximum number of structs to be retrieved. Unlimited if nil. ex: 35 is_delivered [bool, default nil]: filter successfully delivered events. ex: true or false after [Date, default nil]: date filter for structs created only after specified date. ex: ~D[2020-03-25] before [Date, default nil]: date filter for structs only before specified date. ex: ~D[2020-03-25] Return: stream of Event structs with updated attributes","ref":"StarkBank.Event.html#query/2","title":"StarkBank.Event.query/2","type":"function"},{"doc":"Same as query(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.Event.html#query!/2","title":"StarkBank.Event.query!/2","type":"function"},{"doc":"Update notification Event entity Update notification Event by passing id. If is_delivered is true, the event will no longer be returned on queries with is_delivered=false. Parameters (required): user [Project]: Project struct returned from StarkBank.project(). id [list of strings]: Event unique ids. ex: &quot;5656565656565656&quot; Parameters (optional): is_delivered [bool]: If true and event hasn&#39;t been delivered already, event will be set as delivered. ex: true Return: target Event with updated attributes","ref":"StarkBank.Event.html#update/3","title":"StarkBank.Event.update/3","type":"function"},{"doc":"Same as update(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.Event.html#update!/3","title":"StarkBank.Event.update!/3","type":"function"},{"doc":"","ref":"StarkBank.Event.html#t:t/0","title":"StarkBank.Event.t/0","type":"type"},{"doc":"Used to generate API-compatible key pairs","ref":"StarkBank.Key.html","title":"StarkBank.Key","type":"module"},{"doc":"Generate a key pair Generates a secp256k1 ECDSA private/public key pair to be used in the API authentications Parameters (optional): path [string, default nil]: path to save the keys .pem files. No files will be saved if this parameter isn&#39;t provided.","ref":"StarkBank.Key.html#create/1","title":"StarkBank.Key.create/1","type":"function"},{"doc":"Groups Transaction related functions Transaction struct: A Transaction is a transfer of funds between workspaces inside Stark Bank. Transactions created by the user are only for internal transactions. Other operations (such as transfer or charge-payment) will automatically create a transaction for the user which can be retrieved for the statement. When you initialize a Transaction, the entity will not be automatically created in the Stark Bank API. The &#39;create&#39; function sends the structs to the Stark Bank API and returns the list of created structs. Parameters (required): amount [integer]: amount in cents to be transferred. ex: 1234 (= R$ 12.34) description [string]: text to be displayed in the receiver and the sender statements (Min. 10 characters). ex: &quot;funds redistribution&quot; external_id [string]: unique id, generated by user, to avoid duplicated transactions. ex: &quot;transaction ABC 2020-03-30&quot; received_id [string]: unique id of the receiving workspace. ex: &quot;5656565656565656&quot; Parameters (optional): tags [list of strings]: list of strings for reference when searching transactions (may be empty). ex: [&quot;abc&quot;, &quot;test&quot;] Attributes (return-only): id [string, default nil]: unique id returned when Transaction is created. ex: &quot;7656565656565656&quot; sender_id [string]: unique id of the sending workspace. ex: &quot;5656565656565656&quot; fee [integer, default nil]: fee charged when transfer is created. ex: 200 (= R$ 2.00) source [string, default nil]: locator of the entity that generated the transaction. ex: &quot;charge/18276318736&quot; or &quot;transfer/19381639871263/chargeback&quot; created [DateTime, default nil]: creation datetime for the boleto. ex: ~U[2020-03-26 19:32:35.418698Z]","ref":"StarkBank.Transaction.html","title":"StarkBank.Transaction","type":"module"},{"doc":"Create Transactions Send a list of Transaction entities for creation in the Stark Bank API Parameters (required): user [Project]: Project struct returned from StarkBank.project(). transactions [list of Transaction entities]: list of Transaction entities to be created in the API Return: list of Transaction structs with updated attributes","ref":"StarkBank.Transaction.html#create/2","title":"StarkBank.Transaction.create/2","type":"function"},{"doc":"Same as create(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.Transaction.html#create!/2","title":"StarkBank.Transaction.create!/2","type":"function"},{"doc":"Retrieve a specific Transaction Receive a single Transaction entity previously created in the Stark Bank API by passing its id Parameters (required): user [Project]: Project struct returned from StarkBank.project(). id [string]: entity unique id. ex: &quot;5656565656565656&quot; Return: Transaction struct with updated attributes","ref":"StarkBank.Transaction.html#get/2","title":"StarkBank.Transaction.get/2","type":"function"},{"doc":"Same as get(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.Transaction.html#get!/2","title":"StarkBank.Transaction.get!/2","type":"function"},{"doc":"Retrieve Transactions Receive a stream of Transaction entities previously created in the Stark Bank API Parameters (required): user [Project]: Project struct returned from StarkBank.project(). Parameters (optional): limit [integer, default nil]: maximum number of entities to be retrieved. Unlimited if nil. ex: 35 external_ids [list of strings, default nil]: list of external ids to filter retrieved entities. ex: [&quot;5656565656565656&quot;, &quot;4545454545454545&quot;] after [Date, default nil] date filter for entities created only after specified date. ex: Date(2020, 3, 10) before [Date, default nil] date filter for entities created only before specified date. ex: Date(2020, 3, 10) Return: stream of Transaction structs with updated attributes","ref":"StarkBank.Transaction.html#query/2","title":"StarkBank.Transaction.query/2","type":"function"},{"doc":"Same as query(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.Transaction.html#query!/2","title":"StarkBank.Transaction.query!/2","type":"function"},{"doc":"","ref":"StarkBank.Transaction.html#t:t/0","title":"StarkBank.Transaction.t/0","type":"type"},{"doc":"Groups Transfer related functions Transfer struct: When you initialize a Transfer, the entity will not be automatically created in the Stark Bank API. The &#39;create&#39; function sends the structs to the Stark Bank API and returns the list of created structs. Parameters (required): amount [integer]: amount in cents to be transferred. ex: 1234 (= R$ 12.34) name [string]: receiver full name. ex: &quot;Anthony Edward Stark&quot; tax_id [string]: receiver tax ID (CPF or CNPJ) with or without formatting. ex: &quot;01234567890&quot; or &quot;20.018.183/0001-80&quot; bank_code [string]: receiver 1 to 3 digits of the bank institution in Brazil. ex: &quot;200&quot; or &quot;341&quot; branch_code [string]: receiver bank account branch. Use &#39;-&#39; in case there is a verifier digit. ex: &quot;1357-9&quot; account_number [string]: Receiver Bank Account number. Use &#39;-&#39; before the verifier digit. ex: &quot;876543-2&quot; Parameters (optional): tags [list of strings]: list of strings for reference when searching for transfers. ex: [&quot;employees&quot;, &quot;monthly&quot;] Attributes (return-only): id [string, default nil]: unique id returned when Transfer is created. ex: &quot;5656565656565656&quot; fee [integer, default nil]: fee charged when transfer is created. ex: 200 (= R$ 2.00) status [string, default nil]: current boleto status. ex: &quot;registered&quot; or &quot;paid&quot; transaction_ids [list of strings, default nil]: ledger transaction ids linked to this transfer (if there are two, second is the chargeback). ex: [&quot;19827356981273&quot;] created [DateTime, default nil]: creation datetime for the transfer. ex: ~U[2020-03-26 19:32:35.418698Z] updated [DateTime, default nil]: latest update datetime for the transfer. ex: ~U[2020-03-26 19:32:35.418698Z]","ref":"StarkBank.Transfer.html","title":"StarkBank.Transfer","type":"module"},{"doc":"Create Transfers Send a list of Transfer structs for creation in the Stark Bank API Parameters (required): user [Project]: Project struct returned from StarkBank.project(). transfers [list of Transfer structs]: list of Transfer structs to be created in the API Return: list of Transfer structs with updated attributes","ref":"StarkBank.Transfer.html#create/2","title":"StarkBank.Transfer.create/2","type":"function"},{"doc":"Same as create(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.Transfer.html#create!/2","title":"StarkBank.Transfer.create!/2","type":"function"},{"doc":"Retrieve a specific Transfer Receive a single Transfer struct previously created in the Stark Bank API by passing its id Parameters (required): user [Project]: Project struct returned from StarkBank.project(). id [string]: struct unique id. ex: &quot;5656565656565656&quot; Return: Transfer struct with updated attributes","ref":"StarkBank.Transfer.html#get/2","title":"StarkBank.Transfer.get/2","type":"function"},{"doc":"Same as get(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.Transfer.html#get!/2","title":"StarkBank.Transfer.get!/2","type":"function"},{"doc":"Retrieve a specific Transfer pdf file Receive a single Transfer pdf receipt file generated in the Stark Bank API by passing its id. Only valid for transfers with &quot;processing&quot; or &quot;success&quot; status. Parameters (required): user [Project]: Project struct returned from StarkBank.project(). id [string]: struct unique id. ex: &quot;5656565656565656&quot; Return: Transfer pdf file content","ref":"StarkBank.Transfer.html#pdf/2","title":"StarkBank.Transfer.pdf/2","type":"function"},{"doc":"Same as pdf(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.Transfer.html#pdf!/2","title":"StarkBank.Transfer.pdf!/2","type":"function"},{"doc":"Retrieve Transfers Receive a stream of Transfer structs previously created in the Stark Bank API Parameters (required): user [Project]: Project struct returned from StarkBank.project(). Parameters (optional): limit [integer, default nil]: maximum number of structs to be retrieved. Unlimited if nil. ex: 35 status [string, default nil]: filter for status of retrieved structs. ex: &quot;paid&quot; or &quot;registered&quot; tags [list of strings, default nil]: tags to filter retrieved structs. ex: [&quot;tony&quot;, &quot;stark&quot;] transaction_ids [list of strings, default nil]: list of Transaction ids to filter retrieved structs. ex: [&quot;5656565656565656&quot;, &quot;4545454545454545&quot;] after [Date, default nil]: date filter for structs created only after specified date. ex: ~D[2020-03-25] before [Date, default nil]: date filter for structs only before specified date. ex: ~D[2020-03-25] sort [string, default &quot;-created&quot;]: sort order considered in response. Valid options are &#39;created&#39;, &#39;-created&#39;, &#39;updated&#39; or &#39;-updated&#39;. Return: stream of Transfer structs with updated attributes","ref":"StarkBank.Transfer.html#query/2","title":"StarkBank.Transfer.query/2","type":"function"},{"doc":"Same as query(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.Transfer.html#query!/2","title":"StarkBank.Transfer.query!/2","type":"function"},{"doc":"","ref":"StarkBank.Transfer.html#t:t/0","title":"StarkBank.Transfer.t/0","type":"type"},{"doc":"Groups Transfer.Log related functions Transfer.Log struct: Every time a Transfer entity is modified, a corresponding Transfer.Log is generated for the entity. This log is never generated by the user. Attributes: id [string]: unique id returned when the log is created. ex: &quot;5656565656565656&quot; transfer [Transfer]: Transfer entity to which the log refers to. errors [list of strings]: list of errors linked to this BoletoPayment event. type [string]: type of the Transfer event which triggered the log creation. ex: &quot;processing&quot; or &quot;success&quot; created [DateTime]: creation datetime for the transfer. ex: ~U[2020-03-26 19:32:35.418698Z]","ref":"StarkBank.Transfer.Log.html","title":"StarkBank.Transfer.Log","type":"module"},{"doc":"Retrieve a specific Log Receive a single Log struct previously created by the Stark Bank API by passing its id Parameters (required): user [Project]: Project struct returned from StarkBank.project(). id [string]: struct unique id. ex: &quot;5656565656565656&quot; Return: Log struct with updated attributes","ref":"StarkBank.Transfer.Log.html#get/2","title":"StarkBank.Transfer.Log.get/2","type":"function"},{"doc":"Same as get(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.Transfer.Log.html#get!/2","title":"StarkBank.Transfer.Log.get!/2","type":"function"},{"doc":"Retrieve Logs Receive a stream of Log structs previously created in the Stark Bank API Parameters (required): user [Project]: Project struct returned from StarkBank.project(). Parameters (optional): limit [integer, default nil]: maximum number of structs to be retrieved. Unlimited if nil. ex: 35 transfer_ids [list of strings, default nil]: list of Transfer ids to filter retrieved structs. ex: [&quot;5656565656565656&quot;, &quot;4545454545454545&quot;] types [list of strings, default nil]: filter retrieved structs by types. ex: &quot;success&quot; or &quot;failed&quot; after [Date, default nil] date filter for structs created only after specified date. ex: Date(2020, 3, 10) before [Date, default nil] date filter for structs only before specified date. ex: Date(2020, 3, 10) Return: stream of Log structs with updated attributes","ref":"StarkBank.Transfer.Log.html#query/2","title":"StarkBank.Transfer.Log.query/2","type":"function"},{"doc":"Same as query(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.Transfer.Log.html#query!/2","title":"StarkBank.Transfer.Log.query!/2","type":"function"},{"doc":"","ref":"StarkBank.Transfer.Log.html#t:t/0","title":"StarkBank.Transfer.Log.t/0","type":"type"},{"doc":"Groups UtilityPayment related functions UtilityPayment struct: When you initialize a UtilityPayment, the entity will not be automatically created in the Stark Bank API. The &#39;create&#39; function sends the structs to the Stark Bank API and returns the list of created structs. Parameters (conditionally required): line [string, default nil]: Number sequence that describes the payment. Either &#39;line&#39; or &#39;bar_code&#39; parameters are required. If both are sent, they must match. ex: &quot;34191.09008 63571.277308 71444.640008 5 81960000000062&quot; bar_code [string, default nil]: Bar code number that describes the payment. Either &#39;line&#39; or &#39;barCode&#39; parameters are required. If both are sent, they must match. ex: &quot;34195819600000000621090063571277307144464000&quot; Parameters (required): description [string]: Text to be displayed in your statement (min. 10 characters). ex: &quot;payment ABC&quot; Parameters (optional): scheduled [Date, default today]: payment scheduled date. ex: ~D[2020-03-25] tags [list of strings]: list of strings for tagging Attributes (return-only): id [string, default nil]: unique id returned when payment is created. ex: &quot;5656565656565656&quot; status [string, default nil]: current payment status. ex: &quot;registered&quot; or &quot;paid&quot; amount [int, default nil]: amount automatically calculated from line or bar_code. ex: 23456 (= R$ 234.56) fee [integer, default nil]: fee charged when a utility payment is created. ex: 200 (= R$ 2.00) created [DateTime, default nil]: creation datetime for the payment. ex: ~U[2020-03-26 19:32:35.418698Z]","ref":"StarkBank.UtilityPayment.html","title":"StarkBank.UtilityPayment","type":"module"},{"doc":"Create UtilityPayments Send a list of UtilityPayment structs for creation in the Stark Bank API Parameters (required): user [Project struct]: Project struct. Not necessary if starkbank.user was set before function call payments [list of UtilityPayment structs]: list of UtilityPayment structs to be created in the API Return: list of UtilityPayment structs with updated attributes","ref":"StarkBank.UtilityPayment.html#create/2","title":"StarkBank.UtilityPayment.create/2","type":"function"},{"doc":"Same as create(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.UtilityPayment.html#create!/2","title":"StarkBank.UtilityPayment.create!/2","type":"function"},{"doc":"Delete a UtilityPayment entity Delete a UtilityPayment entity previously created in the Stark Bank API Parameters (required): user [Project]: Project struct returned from StarkBank.project(). id [string]: UtilityPayment unique id. ex: &quot;5656565656565656&quot; Return: deleted UtilityPayment with updated attributes","ref":"StarkBank.UtilityPayment.html#delete/2","title":"StarkBank.UtilityPayment.delete/2","type":"function"},{"doc":"Same as delete(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.UtilityPayment.html#delete!/2","title":"StarkBank.UtilityPayment.delete!/2","type":"function"},{"doc":"Retrieve a specific UtilityPayment Receive a single UtilityPayment struct previously created by the Stark Bank API by passing its id Parameters (required): user [Project struct]: Project struct. Not necessary if starkbank.user was set before function call id [string]: struct unique id. ex: &quot;5656565656565656&quot; Return: UtilityPayment struct with updated attributes","ref":"StarkBank.UtilityPayment.html#get/2","title":"StarkBank.UtilityPayment.get/2","type":"function"},{"doc":"Same as get(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.UtilityPayment.html#get!/2","title":"StarkBank.UtilityPayment.get!/2","type":"function"},{"doc":"Retrieve a specific UtilityPayment pdf file Receive a single UtilityPayment pdf file generated in the Stark Bank API by passing its id. Only valid for utility payments with &quot;success&quot; status. Parameters (required): user [Project struct]: Project struct. Not necessary if starkbank.user was set before function call id [string]: struct unique id. ex: &quot;5656565656565656&quot; Return: UtilityPayment pdf file content","ref":"StarkBank.UtilityPayment.html#pdf/2","title":"StarkBank.UtilityPayment.pdf/2","type":"function"},{"doc":"Same as pdf(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.UtilityPayment.html#pdf!/2","title":"StarkBank.UtilityPayment.pdf!/2","type":"function"},{"doc":"Retrieve UtilityPayments Receive a stream of UtilityPayment structs previously created in the Stark Bank API Parameters (required): user [Project]: Project struct returned from StarkBank.project(). Parameters (optional): limit [integer, default nil]: maximum number of structs to be retrieved. Unlimited if nil. ex: 35 status [string, default nil]: filter for status of retrieved structs. ex: &quot;paid&quot; tags [list of strings, default nil]: tags to filter retrieved structs. ex: [&quot;tony&quot;, &quot;stark&quot;] ids [list of strings, default nil]: list of ids to filter retrieved structs. ex: [&quot;5656565656565656&quot;, &quot;4545454545454545&quot;] after [Date, default nil] date filter for structs created only after specified date. ex: Date(2020, 3, 10) before [Date, default nil] date filter for structs only before specified date. ex: Date(2020, 3, 10) Return: stream of UtilityPayment structs with updated attributes","ref":"StarkBank.UtilityPayment.html#query/2","title":"StarkBank.UtilityPayment.query/2","type":"function"},{"doc":"Same as query(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.UtilityPayment.html#query!/2","title":"StarkBank.UtilityPayment.query!/2","type":"function"},{"doc":"","ref":"StarkBank.UtilityPayment.html#t:t/0","title":"StarkBank.UtilityPayment.t/0","type":"type"},{"doc":"Groups UtilityPayment.Log related functions UtilityPayment.Log struct: Every time a UtilityPayment entity is modified, a corresponding UtilityPayment.Log is generated for the entity. This log is never generated by the user, but it can be retrieved to check additional information on the UtilityPayment. Attributes: id [string]: unique id returned when the log is created. ex: &quot;5656565656565656&quot; payment [UtilityPayment]: UtilityPayment entity to which the log refers to. errors [list of strings]: list of errors linked to this BoletoPayment event. type [string]: type of the UtilityPayment event which triggered the log creation. ex: &quot;registered&quot; or &quot;paid&quot; created [DateTime]: creation datetime for the payment. ex: ~U[2020-03-26 19:32:35.418698Z]","ref":"StarkBank.UtilityPayment.Log.html","title":"StarkBank.UtilityPayment.Log","type":"module"},{"doc":"Retrieve a specific Log Receive a single Log struct previously created by the Stark Bank API by passing its id Parameters (required): user [Project]: Project struct returned from StarkBank.project(). id [string]: struct unique id. ex: &quot;5656565656565656&quot; Return: Log struct with updated attributes","ref":"StarkBank.UtilityPayment.Log.html#get/2","title":"StarkBank.UtilityPayment.Log.get/2","type":"function"},{"doc":"Same as get(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.UtilityPayment.Log.html#get!/2","title":"StarkBank.UtilityPayment.Log.get!/2","type":"function"},{"doc":"Retrieve Logs Receive a stream of Log structs previously created in the Stark Bank API Parameters (required): user [Project]: Project struct returned from StarkBank.project(). Parameters (optional): limit [integer, default nil]: maximum number of entities to be retrieved. Unlimited if nil. ex: 35 after [Date, default nil] date filter for entities created only after specified date. ex: Date(2020, 3, 10) before [Date, default nil] date filter for entities only before specified date. ex: Date(2020, 3, 10) payment_ids [list of strings, default nil]: list of UtilityPayment ids to filter retrieved entities. ex: [&quot;5656565656565656&quot;, &quot;4545454545454545&quot;] types [list of strings, default nil]: filter retrieved entities by event types. ex: &quot;paid&quot; or &quot;registered&quot; Return: stream of Log structs with updated attributes","ref":"StarkBank.UtilityPayment.Log.html#query/2","title":"StarkBank.UtilityPayment.Log.query/2","type":"function"},{"doc":"Same as query(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.UtilityPayment.Log.html#query!/2","title":"StarkBank.UtilityPayment.Log.query!/2","type":"function"},{"doc":"","ref":"StarkBank.UtilityPayment.Log.html#t:t/0","title":"StarkBank.UtilityPayment.Log.t/0","type":"type"},{"doc":"Groups Webhook related functions Webhook subscription struct: A Webhook is used to subscribe to notification events on a user-selected endpoint. Currently available services for subscription are transfer, boleto, boleto-payment, and utility-payment Parameters (required): url [string]: Url that will be notified when an event occurs. subscriptions [list of strings]: list of any non-empty combination of the available services. ex: [&quot;transfer&quot;, &quot;boleto-payment&quot;] Attributes: id [string, default nil]: unique id returned when the log is created. ex: &quot;5656565656565656&quot;","ref":"StarkBank.Webhook.html","title":"StarkBank.Webhook","type":"module"},{"doc":"Create Webhook subscription Send a single Webhook subscription for creation in the Stark Bank API Parameters (required): user [Project]: Project struct returned from StarkBank.project(). url [string]: url to which notification events will be sent to. ex: &quot;https://webhook.site/60e9c18e-4b5c-4369-bda1-ab5fcd8e1b29&quot; subscriptions [list of strings]: list of any non-empty combination of the available services. ex: [&quot;transfer&quot;, &quot;boleto-payment&quot;] Return: Webhook struct with updated attributes","ref":"StarkBank.Webhook.html#create/3","title":"StarkBank.Webhook.create/3","type":"function"},{"doc":"Same as create(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.Webhook.html#create!/3","title":"StarkBank.Webhook.create!/3","type":"function"},{"doc":"Delete a Webhook subscription entity Delete a Webhook subscription entity previously created in the Stark Bank API Parameters (required): user [Project]: Project struct returned from StarkBank.project(). id [string]: Webhook unique id. ex: &quot;5656565656565656&quot; Return: deleted Webhook with updated attributes","ref":"StarkBank.Webhook.html#delete/2","title":"StarkBank.Webhook.delete/2","type":"function"},{"doc":"Same as delete(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.Webhook.html#delete!/2","title":"StarkBank.Webhook.delete!/2","type":"function"},{"doc":"Retrieve a specific Webhook subscription Receive a single Webhook subscription struct previously created in the Stark Bank API by passing its id Parameters (required): user [Project]: Project struct returned from StarkBank.project(). id [string]: struct unique id. ex: &quot;5656565656565656&quot; Return: Webhook struct with updated attributes","ref":"StarkBank.Webhook.html#get/2","title":"StarkBank.Webhook.get/2","type":"function"},{"doc":"Same as get(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.Webhook.html#get!/2","title":"StarkBank.Webhook.get!/2","type":"function"},{"doc":"Retrieve Webhook subcriptions Receive a stream of Webhook subcription structs previously created in the Stark Bank API Parameters (required): user [Project]: Project struct returned from StarkBank.project(). Parameters (optional): limit [integer, default nil]: maximum number of structs to be retrieved. Unlimited if nil. ex: 35 Return: stream of Webhook structs with updated attributes","ref":"StarkBank.Webhook.html#query/2","title":"StarkBank.Webhook.query/2","type":"function"},{"doc":"Same as query(), but it will unwrap the error tuple and raise in case of errors.","ref":"StarkBank.Webhook.html#query!/2","title":"StarkBank.Webhook.query!/2","type":"function"},{"doc":"","ref":"StarkBank.Webhook.html#t:t/0","title":"StarkBank.Webhook.t/0","type":"type"}]